<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateVoiceMailPilotReq StructType
 * @subpackage Structs
 */
class UpdateVoiceMailPilotReq extends APIRequest
{
    /**
     * The dirn
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | dirn | cssName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $dirn;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | dirn | cssName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The cssName
     * Meta information extracted from the WSDL
     * - choice: uuid | dirn | cssName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $cssName;
    /**
     * The newDirn
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $newDirn;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The newCssName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $newCssName;
    /**
     * The isDefault
     * Meta information extracted from the WSDL
     * - documentation: In Update setting isDefault tag as false would not disable this VoiceMailPilot as Default. Instead, the corresponding tag of another VoiceMailPilot should be set to true.
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isDefault;
    /**
     * Constructor method for UpdateVoiceMailPilotReq
     * @uses UpdateVoiceMailPilotReq::setDirn()
     * @uses UpdateVoiceMailPilotReq::setUuid()
     * @uses UpdateVoiceMailPilotReq::setCssName()
     * @uses UpdateVoiceMailPilotReq::setNewDirn()
     * @uses UpdateVoiceMailPilotReq::setDescription()
     * @uses UpdateVoiceMailPilotReq::setNewCssName()
     * @uses UpdateVoiceMailPilotReq::setIsDefault()
     * @param string $dirn
     * @param string $uuid
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $cssName
     * @param string $newDirn
     * @param string $description
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $newCssName
     * @param string $isDefault
     */
    public function __construct($dirn = null, $uuid = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $cssName = null, $newDirn = null, $description = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $newCssName = null, $isDefault = null)
    {
        $this
            ->setDirn($dirn)
            ->setUuid($uuid)
            ->setCssName($cssName)
            ->setNewDirn($newDirn)
            ->setDescription($description)
            ->setNewCssName($newCssName)
            ->setIsDefault($isDefault);
    }
    /**
     * Get dirn value
     * @return string
     */
    public function getDirn()
    {
        return isset($this->dirn) ? $this->dirn : null;
    }
    /**
     * Set dirn value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $dirn
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setDirn($dirn = null)
    {
        if (is_null($dirn) || (is_array($dirn) && empty($dirn))) {
            unset($this->dirn);
        } else {
            $this->dirn = $dirn;
        }
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return isset($this->uuid) ? $this->uuid : null;
    }
    /**
     * Set uuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setUuid($uuid = null)
    {
        if (is_null($uuid) || (is_array($uuid) && empty($uuid))) {
            unset($this->uuid);
        } else {
            $this->uuid = $uuid;
        }
        return $this;
    }
    /**
     * Get cssName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getCssName()
    {
        return isset($this->cssName) ? $this->cssName : null;
    }
    /**
     * Set cssName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $cssName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setCssName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $cssName = null)
    {
        if (is_null($cssName) || (is_array($cssName) && empty($cssName))) {
            unset($this->cssName);
        } else {
            $this->cssName = $cssName;
        }
        return $this;
    }
    /**
     * Get newDirn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNewDirn()
    {
        return isset($this->newDirn) ? $this->newDirn : null;
    }
    /**
     * Set newDirn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $newDirn
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setNewDirn($newDirn = null)
    {
        if (is_null($newDirn) || (is_array($newDirn) && empty($newDirn))) {
            unset($this->newDirn);
        } else {
            $this->newDirn = $newDirn;
        }
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get newCssName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getNewCssName()
    {
        return isset($this->newCssName) ? $this->newCssName : null;
    }
    /**
     * Set newCssName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $newCssName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setNewCssName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $newCssName = null)
    {
        if (is_null($newCssName) || (is_array($newCssName) && empty($newCssName))) {
            unset($this->newCssName);
        } else {
            $this->newCssName = $newCssName;
        }
        return $this;
    }
    /**
     * Get isDefault value
     * @return string|null
     */
    public function getIsDefault()
    {
        return $this->isDefault;
    }
    /**
     * Set isDefault value
     * @param string $isDefault
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateVoiceMailPilotReq
     */
    public function setIsDefault($isDefault = null)
    {
        $this->isDefault = $isDefault;
        return $this;
    }
}
